/*
 Copyright (C) JAEHYUK CHO
 All rights reserved.
 Code by JaeHyuk Cho <mailto:minzkn@minzkn.com>

 SIMPLE IS BEST !
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mzmixer.h"

static int (mzmixer_list)(t_mzapi_mixer *s_mixer, const char *s_name)
{
 int s_result = EXIT_SUCCESS, s_mute, s_left, s_right;
 t_mzapi_mixer_device *s_device = s_name ? s_mixer->search_by_name(s_mixer, s_name) : s_mixer->device;
 (void)fputs("=============================\n NAME     ID    [L] [R] MUTE \n-----------------------------\n", stdout);
 while(s_device)
 {
  if(s_mixer->get_volume_by_id(s_mixer, s_device->id, &s_mute, &s_left, &s_right) == 1)(void)fprintf(stdout, " %-8s %04XH %3d %3d %s\n", s_device->name ? s_device->name : "NULL", s_device->id, s_left, s_right, (s_mute == 0) ? "OFF" : "ON");
  else
  {
   (void)fprintf(stdout, " %-8s%s\n", s_device->name ? s_device->name : "NULL", "error");
   s_result = EXIT_FAILURE;
  }
  if(s_name)break;
  s_device = s_device->next;
 }
 (void)fputs("=============================\n", stdout);
 return(s_result);
}

int (main)(int s_argc, char **s_argv)
{
 int s_result = EXIT_SUCCESS, s_mute = (-1), s_left = (-1), s_right = (-1);
 t_mzapi_mixer *s_mixer = mzapi_open_mixer(NULL);
 if(!s_mixer)return(EXIT_FAILURE);
 if(s_argc >= 2)
 { 
  if(s_argc >= 3)
  {
   if((strcmp(s_argv[2], "mute") == 0) || (strcmp(s_argv[2], "muteon") == 0) || (strcmp(s_argv[2], "off") == 0))s_mute = 1;
   else if((strcmp(s_argv[2], "muteoff") == 0) || (strcmp(s_argv[2], "on") == 0))s_mute = 0;
   else
   {
    s_left = atoi(s_argv[2]);
    s_right = (s_argc >= 4) ? atoi(s_argv[3]) : s_left;
   }
   if(s_mixer->set_volume_by_name(s_mixer, s_argv[1], s_mute, s_left, s_right) == 0)s_result = EXIT_FAILURE;
  }
  s_result = mzmixer_list(s_mixer, s_argv[1]);
 } 
 else s_result = mzmixer_list(s_mixer, NULL);
 (void)mzapi_close_mixer(s_mixer);
 return(s_result);
}

/* vim: set expandtab: */
/* End of source */
