/*
 Copyright (C) JAEHYUK CHO
 All rights reserved.
 Code by JaeHyuk Cho <mailto:minzkn@minzkn.com>
*/

#if !defined(__def_mzapi_header_mzmixer_h__)
#define __def_mzapi_header_mzmixer_h__ "mzmixer.h"

#include <sys/soundcard.h>

struct ts_mzapi_mixer_device
{
 struct ts_mzapi_mixer_device *next;
 char *name;
 int id;
};

typedef struct ts_mzapi_mixer_device                                 t_mzapi_mixer_device;

struct ts_mzapi_mixer
{
 char *device_name;
 int handle;
 int devices;
 struct ts_mzapi_mixer_device *device;
 /* member function */
 struct ts_mzapi_mixer_device * (* search_by_name)(struct ts_mzapi_mixer *, const char *);
 struct ts_mzapi_mixer_device * (* search_by_id)(struct ts_mzapi_mixer *, int);
 int (* set_volume_by_name)(struct ts_mzapi_mixer *, const char *, int, int, int);
 int (* set_volume_by_id)(struct ts_mzapi_mixer *, int, int, int, int);
 int (* get_volume_by_name)(struct ts_mzapi_mixer *, const char *, int *, int *, int *);
 int (* get_volume_by_id)(struct ts_mzapi_mixer *, int, int *, int *, int *);
};

typedef struct ts_mzapi_mixer                                        t_mzapi_mixer;

#if defined(__cplusplus)
extern "C" {
#endif

#if !defined(__def_mzapi_source_mzmixer_c__)
extern struct ts_mzapi_mixer * (mzapi_open_mixer)(const char * s_device_name);
extern struct ts_mzapi_mixer * (mzapi_close_mixer)(struct ts_mzapi_mixer *s_mixer);

static __inline int (mzapi_set_volume)(const char *s_name, int s_left, int s_right)
{
 int s_result;
 struct ts_mzapi_mixer *s_mixer = mzapi_open_mixer((char *)0);
 if(s_mixer == ((struct ts_mzapi_mixer *)0))return(-1);
 s_result = s_mixer->set_volume_by_name(s_mixer, s_name, s_left, s_right, 0);
 (void)mzapi_close_mixer(s_mixer);
 return(s_result);
}

static __inline int (mzapi_get_volume)(const char *s_name, int *s_left, int *s_right)
{
 int s_result;
 struct ts_mzapi_mixer *s_mixer = mzapi_open_mixer((char *)0);
 if(s_mixer == ((struct ts_mzapi_mixer *)0))return(-1);
 s_result = s_mixer->get_volume_by_name(s_mixer, s_name, s_left, s_right, (int *)0);
 (void)mzapi_close_mixer(s_mixer);
 return(s_result);
}
#endif

#if defined(__cplusplus)
}
#endif

#endif

/* vim: set expandtab: */
/* End of source */
